<!DOCTYPE HTML> 
<html lang="en"> 
<head>
<title>MP4 - aychen3</title>
<meta charset="utf-8"> 
</head>
	
<script id="blinnphongshader-vs" type="x-shader/x-vertex">
	attribute vec3 aVertexNormal;
	attribute vec3 aVertexPosition;
   
	uniform mat4 uMVMatrix;
	uniform mat4 uPMatrix;
	uniform mat3 uNMatrix;
	varying vec3 vNormal;
	varying vec3 vPosition;

	varying vec3 heightcolor;
	
	void main(void) {
		// Get the vertex position in eye coordinates
		vec4 vertexPositionEye4 = uMVMatrix * vec4(aVertexPosition, 1.0);
		vPosition = vertexPositionEye4.xyz / vertexPositionEye4.w;
		//Calaulate the normal
		vNormal = normalize(uNMatrix * aVertexNormal);
	   
		gl_Position = uPMatrix*uMVMatrix*vec4(aVertexPosition, 1.0);
	}
</script>

<script id="blinnphongshader-fs" type="x-shader/x-fragment">
	precision mediump float;
	varying vec3 vNormal;
	varying vec3 vPosition;

	uniform vec3 uLightPosition;
	uniform vec3 uAmbientLightColor;
	uniform vec3 uDiffuseLightColor;
	uniform vec3 uSpecularLightColor;
	uniform vec3 uAmbientMaterialColor;
	uniform vec3 uDiffuseMaterialColor;
	uniform vec3 uSpecularMaterialColor;
	uniform float uShininess;

	void main(void) {
		vec4 vColor;
		// Calculate the vector (l) to the light source
		vec3 vectorToLightSource = normalize(uLightPosition - vPosition);
		
		// Calculate n dot l for diffuse lighting
		float diffuseLightWeightning = max(dot(vNormal, 
										vectorToLightSource), 0.0);
		
		// The camera in eye coordinates is located in the origin and is pointing
		// along the negative z-axis. Calculate viewVector (v) 
		// in eye coordinates as:
		// (0.0, 0.0, 0.0) - vertexPositionEye3
		vec3 viewVectorEye = -normalize(vPosition);
										   
		// Calculate the reflection vector (r) that is needed for specular light
		vec3 halfwayVector = normalize(vectorToLightSource+viewVectorEye);

		float ndoth = max(dot(halfwayVector, viewVectorEye), 0.0);
		
		float specularLightWeightning = pow(ndoth, uShininess);

		// Sum up all three reflection components and send to the fragment shader
		vColor = vec4(((uAmbientLightColor*uAmbientMaterialColor)
					+ (uDiffuseLightColor*uDiffuseMaterialColor) * diffuseLightWeightning
					+ (uSpecularLightColor*uSpecularMaterialColor) * specularLightWeightning),1.0);


		gl_FragColor = vColor;
	}
</script>

<script src="gl-matrix-min.js"></script> 
<script src="webgl-utils.js"></script>
<script src="simpleModeling.js"></script>   
<script src="Spheres.js"></script>   
<body onload="startup();">
	<canvas id="myGLCanvas" width="800" height="500" onclick="addBalls()"></canvas>
		<aside>
	<table>
		<tr>
			<th>Key</th>
			<th>Function</th> 
		</tr>
		<tr>
			<td>Left Arrow</td>
			<td>Orbit camera left.</td>
		</tr>
		<tr>
			<td>Right Arrow</td>
			<td>Orbit camera right.</td>
		</tr>
		<tr>
			<td>Up Arrow</td>
			<td>Orbit camera up.</td>
		</tr>
		<tr>
			<td>Down Arrow</td>
			<td>Orbit camera down.</td>
		</tr>
		<tr>
			<td>Mouse Left-Click Screen</td>
			<td>Add 2 balls.</td>
		</tr>
		<tr>
			<td>c</td>
			<td>Clear all balls.</td>
		</tr>
		<tr>
			<td>r</td>
			<td>Reset Camera.</td>
		</tr>
		<tr>
			<td>q</td>
			<td>Reset Everything.</td>
		</tr>
	</table>
	</aside>
</table>
</body>

</html>
